<!-- color editor - implemented before vuetify color picker was found... -->

<template>
    <div class="container">
		<v-menu offset-y :close-on-content-click="false" v-model="show">
            <template v-slot:activator="{ on }">
                <span class="caption">{{ label }}</span>
                <v-btn class="showbutton" :color="value.rgb" v-on="on" small>▼</v-btn> 
            </template> 
            <div class="dropdown"> 
                <chrome-picker :value="value" @input="updateValue"/>
                <v-btn class="b" small @click="ok">Ok</v-btn> 
                <v-btn class="b" small @click="cancel">Cancel</v-btn> 
            </div>    
		</v-menu>
    </div>
</template>

<script lang="ts">
import Vue from 'vue'
import { Sketch } from 'vue-color';


export default Vue.extend({
    props: {
        value: {
            required: true  // { rgb: "#ff0000", a=0.8 }
        },
        label: {
            required: true            
        }
    },

    data() {
        return {
            rgb: "",
            a: 1,
            show: false
        }
    },
	
	methods: {
        ok(): void {
            this.show = false;
			this.$emit('input', { rgb: this.rgb, a: this.a });
        },


        cancel(): void {
            this.show = false;
        },

		updateValue(color): void {
            //console.log(color);
            this.rgb = color.hex;
            this.a = color.a;
		},			
	},
	watch: {
    },

    components: { 'chrome-picker': Sketch }
});
</script>

<style scoped>
.container {
    width: 100%;
    margin: 0px;
    padding: 0px;
    margin-top: 2px;
    text-align: left;
}

.caption {
    color: lightgray;
    display: inline-block;
    text-align: left;
    width: calc(100% - 60px);
    margin: 0px;
    padding: 0px;
}

.showbutton {
    display: inline-block;
}

.dropdown {
    padding: 0px;
    background-color: white;
}

.b {
    margin: 5px;
}
</style>
